/************************************
*	Titel: Praktikum 4				*
*	Dozent: Prof. Kristl			*
*	Stand: WS2011					*
*	Beschreibung: Dreieck malen.	*
_________________________           * 
*******  *******        1			
 *****    *   *         2			
  ***      * *          3			
   *        *           4			
__________________________  	
VOLL      KONTUR      Zeile   
************************************/

#include <stdio.h>

void malSimpl(iZeilenZahl)
{
	int x, counter = 1, fill_counter, space_left = 0, space_middle = 0;
	fill_counter = 2*iZeilenZahl-1;

	printf("\n");

	do
	{
		//Leerzeichen vorne
		for(x = 1; x <= space_left; x++)
		{
			printf(" ");
		}

		//Erste Zeile durchgehend printen
		if(counter == 1)
		{
			for(x = 3; x <= fill_counter; x++)
			{
				printf("*");
			}              
		}

		printf("*");
		//Freiraum ausgeben
		for(x=1; x<=space_middle; x++)
		{
			printf(" ");
		}

		fill_counter = fill_counter - 2;
		counter = counter + 1;
		space_left = counter - 1;

		//Hinteres Sternchen ausgeben
		if(counter >= 2 && counter <= iZeilenZahl)
		{       
			printf("*");
			space_middle = fill_counter;
			space_middle = space_middle - 2;           
		}
		else
		{
			space_middle = 0;
		}
		//Leerzeichen hinten(damit die Tabulatoren am gleichen Punkt anfangen!)
		for(x = 1; x <= space_left; x++)
		{
			printf(" ");
		}
		//Aktuelle Zeilenzahl rechts untereinander Printen
		printf("\t");
		printf("%i", (counter - 1));
		printf("\n");  
	} while(counter <= iZeilenZahl);
	printf("\n");
}

void malDreieck(int iZeilenZahl, int iVariante, char cFill[100])
{
	int x, counter = 1, fill_counter, space_left = 0, space_middle = 0;
	fill_counter = 2*iZeilenZahl-1;

	printf("\n");

	do
	{
		//Leerzeichen vorne
		for(x=1; x<=space_left; x++)
		{
			printf(" ");
		}
		//Variationen auswhlen
		switch (iVariante)
		{
			case 1: //Fuellzeichen ausgeben
				for(x=1; x<=fill_counter; x++)
				{
					printf("%s", cFill);
				}
				//Leerzeichen hinten(damit die Tabulatoren am gleichen Punkt anfangen!
				for(x = 1; x <= space_left; x++)
				{
					printf(" ");
				}
				fill_counter=fill_counter-2;
				counter=counter+1;
				space_left=counter-1;
				break;

			case 2:
				//Erste Zeile durchgehend printen
				if(counter == 1)
				{
					for(x = 3; x <= fill_counter; x++)
					{
						printf("%s", cFill);
					}              
				}

				//Freiraum ausgeben
				printf("%s", cFill);
				for(x = 1; x <= space_middle; x++)
				{
					printf(" ");
				}

				fill_counter = fill_counter-2;
				counter = counter+1;
				space_left = counter-1;

				//Hinteres Zeichen ausgeben
				if(counter >= 2 && counter <= iZeilenZahl)
				{       
					printf("%s", cFill);
					space_middle = fill_counter;
					space_middle = space_middle-2;           
				}
				else
				{
					space_middle = 0;
				}
				//Leerzeichen hinten(damit die Tabulatoren am gleichen Punkt anfangen!)
				for(x = 1; x <= space_left; x++)
				{
					printf(" ");
				}
				break;  
		}
		//Aktuelle Zeilenzahl rechts untereinander Printen
		printf("\t");
		printf("%i", (counter-1));
		printf("\n"); 
	} while(counter <= iZeilenZahl); 
}

int main (void)
{
	char cMenu, cFill[100];
	int iZeilenZahl, iVariante;

	do
	{
		printf("\n\n***\tDREIECK MALEN\t***\n\n");
		printf("(1) Standardform\n(2) Luxusform\n(E) Ende\n");
		fflush(stdout);
		do cMenu = getchar(); while(cMenu == '\n');
		switch (cMenu)
		{
			case '1':
				printf("Gib Zeilenzahl: \n");
				fflush(stdout);

				//Abfrage
				scanf("%i", &iZeilenZahl);
				malSimpl(iZeilenZahl);
				break;

			case '2':
				printf("Gib Variante, Fuellzeichen und Zeilenzahl:\n ");
				fflush(stdout);

				//Abfrage  
				printf("Wieviele Zeilen:\n");
				scanf("%i", &iZeilenZahl);
				printf("\n");
				printf("Welche Variante:\n");
				printf("1. Voll");
				printf("\n");
				printf("2. Kontur \n");
				scanf("%i", &iVariante);
				printf("\n");
				printf("Welches Fuellzeichen:\n");
				scanf("%s", cFill);
				printf("\n\n");
				malDreieck(iZeilenZahl, iVariante, cFill);
				break;
		}
	} while (cMenu != 'E' && cMenu != 'e');   

	return 0;
}